// Node.h: Schnittstelle fr die Klasse Node.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NODE_H__A849F97A_B986_47AC_8352_6BD2CF75291F__INCLUDED_)
#define AFX_NODE_H__A849F97A_B986_47AC_8352_6BD2CF75291F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <Inventor/SbLinear.h>

class Node  
{
public:
	Node(SbVec3f pos,SbVec3f vel);
	virtual ~Node();

	float damping;
	float mass;

	bool stiff;

	SbVec3f velocity;	//float velocity[3]
	SbVec3f position;	//float position[3]
	SbVec3f force;		//float force[3]
	
	
	void addDamping();
	void addForce(SbVec3f f);
	void addGravity();
	void getDerivatives(float* dx, float *dv);
	void getState(float* x, float* v);
	void resetForce();
	void setPosition(SbVec3f p);
	void setState(float* x, float* v);
	void update();

};

#endif // !defined(AFX_NODE_H__A849F97A_B986_47AC_8352_6BD2CF75291F__INCLUDED_)
