// Simulation.cpp: Implementierung der Klasse Simulation.
//
//////////////////////////////////////////////////////////////////////

#include <iostream>
using std::iostream;
using std::cout;
using std::cerr;
using std::endl;
#include <tchar.h>

#include "Simulation.h"


float Simulation::simStepsize=0.01f;
//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

Simulation::Simulation()
{
	init();
}

Simulation::~Simulation()
{
}

void Simulation::init()
{
	pause = true;

	nodeRadius=2.0f;
	createNodes();
	createSprings();
	createWalls();

	projector = NULL;
	force = NULL;

	x = new float[3*nMovNodes];
	v = new float[3*nMovNodes];
	x0 = new float [3*nMovNodes];
	v0 = new float [3*nMovNodes];
	l1 = new float [3*nMovNodes];
	k1 = new float [3*nMovNodes];
	l2 = new float [3*nMovNodes];
	k2 = new float [3*nMovNodes];
	l3 = new float [3*nMovNodes];
	k3 = new float [3*nMovNodes];
	l4 = new float [3*nMovNodes];
	k4 = new float [3*nMovNodes];
}


void Simulation::createNodes()
{
	int i;

	//hard coded at the moment
	nNodes = 2;
	nMovNodes = 2;

	nodes.reserve(nNodes);
	tempNodes.reserve(nNodes);
	//for(i=0; i < nNodes; i++)
	//{
		
	//	if((i%2)==0)
	//	{
	//		cerr << "We have a fixed node: " << i << endl;
	//		nodes[nMovNodes+(i/2)] = new Node(SbVec3f(i,i,i),SbVec3f(0.0f,0.0f,0.0f));
	//		nodes[nMovNodes+(i/2)]->stiff = true;
	//	}
	//	else
	//	{	
	//		cerr << "We have a movable node: " << i << endl;
	//		nodes[i-1] = new Node(SbVec3f(i,i,i),SbVec3f(0.0f,0.0f,0.0f));
	//	}
	//}
	nodes[0] = new Node(SbVec3f(0.0f,0.0f,0.0f),SbVec3f(0.0f,0.0f,0.0f));
	//nodes[0]->stiff = true;

	nodes[1] = new Node(SbVec3f(10.0f,0.0f,0.0f),SbVec3f(0.0f,0.0f,0.0f));
	//nodes[2] = new Node(SbVec3f(2.0f,0.0f,2.0f),SbVec3f(0.0f,0.0f,0.0f));
	//nodes[2]->stiff = true;
	//nodes[3] = new Node(SbVec3f(0.0f,0.0f,2.0f),SbVec3f(0.0f,0.0f,0.0f));

	//nodes[4] = new Node(SbVec3f(0.0f,2.0f,2.0f),SbVec3f(0.0f,0.0f,0.0f));
	//nodes[5] = new Node(SbVec3f(0.0f,2.0f,0.0f),SbVec3f(0.0f,0.0f,0.0f));
	//nodes[6] = new Node(SbVec3f(2.0f,2.0f,0.0f),SbVec3f(0.0f,0.0f,0.0f));
	//nodes[7] = new Node(SbVec3f(2.0f,2.0f,2.0f),SbVec3f(0.0f,0.0f,0.0f));
	//nodes[8] = new Node(SbVec3f(0.05f,4.5f,-0.05f),SbVec3f(0.0f,0.0f,0.0f));
	

	//cerr << "Printing nodes vector:" << endl;
	//for(i=0; i < nNodes; i++)
	//{
	//	cerr << nodes[i] << endl;
//	}

	//cerr << "Nodes created, visual components follow..." << endl;

	spheres.reserve(nNodes);
	nodeTrans.reserve(nNodes);
	for(i=0; i < nNodes; i++)
	{
		//cerr << "Creating SoSphere and SoTranslation for node nr. " << i << endl;
		spheres[i] = new SoSphere;
		spheres[i]->radius.setValue(nodeRadius);
		spheres[i]->setUserData(nodes[i]);
		//cerr << "SoSphere created." << endl;

		nodeTrans[i] = new SoTranslation;
		//cerr << "SoTranslation created" << endl;
		nodeTrans[i]->translation.setValue(nodes[i]->position);
		//cerr << "Value for SoTranslation set." << endl;
		//cerr << "Node completely created." << endl;
	}	 
	
	//cerr << "Nodes completely created." << endl;

}

void Simulation::createSprings()
{
	int i;

	//hard coded at the moment
	//nSprings = 28;

	springs.reserve(nSprings);

	/*springs[0] = new Spring(nodes[0], nodes[1]);
	springs[1] = new Spring(nodes[1], nodes[2]);
	springs[2] = new Spring(nodes[2], nodes[3]);
	springs[3] = new Spring(nodes[3], nodes[0]);
	springs[4] = new Spring(nodes[3], nodes[4]);
	springs[5] = new Spring(nodes[4], nodes[5]);
	springs[6] = new Spring(nodes[5], nodes[6]);
	springs[7] = new Spring(nodes[6], nodes[7]);
	springs[8] = new Spring(nodes[7], nodes[4]);
	springs[9] = new Spring(nodes[0], nodes[5]);
	springs[10] = new Spring(nodes[1], nodes[6]);
	springs[11] = new Spring(nodes[2], nodes[7]);
	springs[12] = new Spring(nodes[0], nodes[7]);
	springs[13] = new Spring(nodes[1], nodes[4]);
	springs[14] = new Spring(nodes[3], nodes[6]);
	springs[15] = new Spring(nodes[5], nodes[2]);
	springs[16] = new Spring(nodes[0], nodes[4]);
	springs[17] = new Spring(nodes[0], nodes[6]);
	springs[18] = new Spring(nodes[1], nodes[5]);
	springs[19] = new Spring(nodes[1], nodes[7]);
	springs[20] = new Spring(nodes[2], nodes[6]);
	springs[21] = new Spring(nodes[2], nodes[4]);
	springs[22] = new Spring(nodes[3], nodes[5]);
	springs[23] = new Spring(nodes[3], nodes[7]);
	springs[24] = new Spring(nodes[0], nodes[2]);
	springs[25] = new Spring(nodes[1], nodes[3]);
	springs[26] = new Spring(nodes[4], nodes[6]);
	springs[27] = new Spring(nodes[5], nodes[7]);
	//for(i=0; i<nSprings; i++)
	//{
	//	springs[i] = new Spring(nodes[i], nodes[i+1]);
	//}
	*/
	cylinders.reserve(nSprings);
	springTrans.reserve(nSprings);
	for(i=0; i<nSprings; i++)
	{
		cylinders[i] = new SoCylinder;
		cylinders[i]->radius.setValue(0.025f);
		cylinders[i]->height.setValue(springs[i]->currentLength);
		cylinders[i]->setUserData(springs[i]);

		springTrans[i] = new SoTransform;
		springTrans[i]->pointAt(springs[i]->position, springs[i]->node1->position);
	}
}

void Simulation::createWalls()
{
	//hard coded size
	xmin = -20.0f;
	xmax =  20.0f;
	ymin = -20.0f;
	ymax =  20.0f;
	zmin = -20.0f;
	zmax =  20.0f;
	nWalls = 6;
	
	//create planes for the model
	planes.reserve(nWalls);
	//zmin-plane; e.g. the floor
	planes[0] = new SbPlane(SbVec3f(0.0f,0.0f,zmin),SbVec3f(1.0f,0.0f,zmin),SbVec3f(0.0f,1.0f,zmin));
	//zmax-plane; e.g. the ceiling
	planes[1] = new SbPlane(SbVec3f(0.0f,0.0f,zmax),SbVec3f(1.0f,0.0f,zmax),SbVec3f(0.0f,1.0f,zmax));
	//xmin-plane
	planes[2] = new SbPlane(SbVec3f(xmin,0.0f,0.0f),SbVec3f(xmin,1.0f,0.0f),SbVec3f(xmin,0.0f,1.0f));
	//xmax-plane 
	planes[3] = new SbPlane(SbVec3f(xmax,0.0f,0.0f),SbVec3f(xmax,1.0f,0.0f),SbVec3f(xmax,0.0f,1.0f));
	//ymin-plane
	planes[4] = new SbPlane(SbVec3f(0.0f,ymin,0.0f),SbVec3f(1.0f,ymin,0.0f),SbVec3f(0.0f,ymin,1.0f));
	//ymax-plane
	planes[5] = new SbPlane(SbVec3f(0.0f,ymax,0.0f),SbVec3f(1.0f,ymax,0.0f),SbVec3f(0.0f,ymax,1.0f));

}

void Simulation::addSeparator(SoSeparator *root)
{
   //add separator for nodes
   SoSeparator *nodeSeparator = new SoSeparator;
   root->addChild(nodeSeparator);

   //node properties
   SoMaterial *nodeMaterial = new SoMaterial;
   nodeMaterial->diffuseColor.setValue(0.9f, 0.0f, 0.0f);
   nodeSeparator->addChild(nodeMaterial);

   //add nodes with their transforms
   for(int i=0; i<nNodes; i++)
   {
		Node *node=nodes[i];
		if(!nodes[i]->stiff)
		{
			 SoSeparator *nSeparator = new SoSeparator;
			 nodeSeparator->addChild(nSeparator);
			 nSeparator->addChild(nodeTrans[i]);
			 nSeparator->addChild(spheres[i]);
		 }
   }

   //add separator for stiff nodes
   SoSeparator *stiffNodeSeparator = new SoSeparator;
   root->addChild(stiffNodeSeparator);

   //fixed node properties
   SoMaterial *stiffNodeMaterial = new SoMaterial;
   stiffNodeMaterial->diffuseColor.setValue(0.0f, 0.0f, 0.9f);
   stiffNodeSeparator->addChild(stiffNodeMaterial);

   //add fixed nodes with their transforms
   for(i=0; i<nNodes; i++)
   {
		if(nodes[i]->stiff)
		{
			SoSeparator *nSeparator=new SoSeparator;
			stiffNodeSeparator->addChild(nSeparator);
			nSeparator->addChild(nodeTrans[i]);
        	nSeparator->addChild(spheres[i]);
		}
   }

   //add separator for springs
   SoSeparator *springSeparator = new SoSeparator;
   root->addChild(springSeparator);

   //spring properties
   SoMaterial *springMaterial = new SoMaterial;
   springMaterial->diffuseColor.setValue(0.9f, 0.9f, 0.9f);
   springSeparator->addChild(springMaterial);

   //create common rotation
   SoTransform *cylinderOrientation = new SoTransform;
   cylinderOrientation->pointAt(SbVec3f(0.0f, 0.0f, 0.0f), SbVec3f(0.0f, -1.0f, 0.0f));

   //add springs with their transforms
   for(i=0; i<nSprings; i++)
   {
      SoSeparator *sSeparator=new SoSeparator;
      springSeparator->addChild(sSeparator);
      sSeparator->addChild(springTrans[i]);
      sSeparator->addChild(cylinderOrientation);
      sSeparator->addChild(cylinders[i]);
   }

   //add separator for walls
	SoSeparator *wallSeparator = new SoSeparator();
	root->addChild(wallSeparator);

	//wall properties
	SoMaterial *wallMaterial = new SoMaterial();
	wallMaterial->diffuseColor.setValue(0.0f, 1.0f, 1.0f);
	wallMaterial->emissiveColor.setValue(0.5f, 0.5f, 0.5f);
	wallSeparator->addChild(wallMaterial);

	SoFaceSet *walls = new SoFaceSet[5];
	//put the nodes on the state for the SoFaceSet
	//SbVec3fList *vec3fList = new SbVec3fList;
	SbVec3f *points = new SbVec3f[4];
	SoCoordinate3 *coordinate3 = new SoCoordinate3;
	SoMFVec3f *mfVec3f = new SoMFVec3f;

	//zmin-wall
	points[3] = *new SbVec3f(xmin, zmin, ymin);
	points[2] = *new SbVec3f(xmax, zmin, ymin);
	points[1] = *new SbVec3f(xmax, zmin, ymax);
	points[0] = *new SbVec3f(xmin, zmin, ymax);
	mfVec3f->setValues(0,4,points);
	coordinate3->point = *mfVec3f;
	wallSeparator->addChild(coordinate3);
	SoFaceSet *wall = new SoFaceSet();
	wall->numVertices = 4;
	walls[0] = *wall;
	wallSeparator->addChild(wall);
	//zmax-wall
	points = new SbVec3f[4];
	points[0] = *new SbVec3f(xmin, zmax, ymin);
	points[1] = *new SbVec3f(xmax, zmax, ymin);
	points[2] = *new SbVec3f(xmax, zmax, ymax);
	points[3] = *new SbVec3f(xmin, zmax, ymax);
	mfVec3f = new SoMFVec3f;
	mfVec3f->setValues(0,4,points);
	coordinate3 = new SoCoordinate3;
	coordinate3->point = *mfVec3f;
	wallSeparator->addChild(coordinate3);
	wall = new SoFaceSet();
	wall->numVertices = 4;
	walls[1] = *wall;
	wallSeparator->addChild(wall);

	//xmin-wall
	points = new SbVec3f[4];
	points[0] = *new SbVec3f(xmin, zmin, ymin);
	points[1] = *new SbVec3f(xmin, zmax, ymin);
	points[2] = *new SbVec3f(xmin, zmax, ymax);
	points[3] = *new SbVec3f(xmin, zmin, ymax);
	mfVec3f = new SoMFVec3f;
	mfVec3f->setValues(0,4,points);
	coordinate3 = new SoCoordinate3;
	coordinate3->point = *mfVec3f;
	wallSeparator->addChild(coordinate3);
	wall = new SoFaceSet();
	wall->numVertices = 4;
	walls[2] = *wall;
	wallSeparator->addChild(wall);

	//transparent wall properties
	wallMaterial = new SoMaterial();
	wallMaterial->diffuseColor.setValue(0.0f, 1.0f, 1.0f);
	wallMaterial->emissiveColor.setValue(0.5f, 0.5f, 0.5f);
	//wallMaterial->transparency.setValue(1.0f);
	wallSeparator->addChild(wallMaterial);
	//xmax-wall
	points = new SbVec3f[4];
	points[0] = *new SbVec3f(xmax, zmin, ymin);
	points[1] = *new SbVec3f(xmax, zmax, ymin);
	points[2] = *new SbVec3f(xmax, zmax, ymax);
	points[3] = *new SbVec3f(xmax, zmin, ymax);
	mfVec3f = new SoMFVec3f;
	mfVec3f->setValues(0,4,points);
	coordinate3 = new SoCoordinate3;
	coordinate3->point = *mfVec3f;
	wallSeparator->addChild(coordinate3);
	wall = new SoFaceSet();
	wall->numVertices = 4;
	walls[3] = *wall;
	wallSeparator->addChild(wall);

	//ymin-wall
	points = new SbVec3f[4];
	points[0] = *new SbVec3f(xmin, zmin, ymin);
	points[1] = *new SbVec3f(xmax, zmin, ymin);
	points[2] = *new SbVec3f(xmax, zmax, ymin);
	points[3] = *new SbVec3f(xmin, zmax, ymin);
	mfVec3f = new SoMFVec3f;
	mfVec3f->setValues(0,4,points);
	coordinate3 = new SoCoordinate3;
	coordinate3->point = *mfVec3f;
	wallSeparator->addChild(coordinate3);
	wall = new SoFaceSet();
	wall->numVertices = 4;
	walls[4] = *wall;
	wallSeparator->addChild(wall);

	//ymax-wall
//	points = new SbVec3f[4];
//	/points[0] = *new SbVec3f(xmin, zmin, ymax);
//	points[1] = *new SbVec3f(xmax, zmin, ymax);
//	points[2] = *new SbVec3f(xmax, zmax, ymax);
//	points[3] = *new SbVec3f(xmin, zmax, ymax);
//	mfVec3f = new SoMFVec3f;
//	mfVec3f->setValues(0,4,points);
//	coordinate3 = new SoCoordinate3;
//	coordinate3->point = *mfVec3f;
//	wallSeparator->addChild(coordinate3);
//	wall = new SoFaceSet();
//	wall->numVertices = 4;
//	walls[5] = *wall;
//	wallSeparator->addChild(wall);
}

void Simulation::animate()
{
	nimLeapFrog();
	//nimRungeKutta4();
}

void Simulation::updateSprings(void)
{
   //Update springs
   for(int i=0; i<nSprings; i++)
   {
      springs[i]->update();
   }
}

void Simulation::computeForces(void)
{
   //Clear forces
   for(int i=0; i<nNodes; i++)
   {
      nodes[i]->resetForce();
   }

   //cerr << "computeForces: forces were reset." << endl;

   //Add gravity forces
   for(i=0; i<nNodes; i++)
   {
      nodes[i]->addGravity();
   }

   //cerr << "computeForces: gravity added." << endl;

   //Add damping forces
   for(i=0; i<nNodes; i++)
   {
      nodes[i]->addDamping();
   }

   //cerr << "computeForces: damping added." << endl;

   //Add grab force
   if(force!=NULL)
   {
      force->applyForce();
   }

   //cerr << "computeForces: force applied." << endl;

   //Add spring forces
   for(i=0; i<nSprings; i++)
   {
      //if(!springs[i]->FullFixed())
      //{
         springs[i]->addForces();
      //}
   }

   //cerr << "computeForces: spring fores added." << endl;
}

void Simulation::detectWallCollisions(float *x, float *v)
{
	if(x[0]-nodeRadius < xmin)
	{
		x[0] = xmin+nodeRadius;
		v[0] = -v[0];
	}
	if(x[0]+nodeRadius > xmax)
	{
		x[0] = xmax-nodeRadius;
		v[0] = -v[0];
	}
	if(x[1]-nodeRadius < zmin)
	{
		x[1] = zmin+nodeRadius;
		v[1] = -v[1];
	}
	if(x[1]+nodeRadius > zmax)
	{
		x[1] = zmax-nodeRadius;
		v[1] = -v[1];
	}
	if(x[2]-nodeRadius < ymin)
	{
		x[2] = ymin+nodeRadius;
		v[2] = -v[2];
	}
	if(x[2]+nodeRadius > ymax)
	{
		x[2] = ymax-nodeRadius;
		v[2] = -v[2];
	}

}

void Simulation::detectNodeCollisions(float *x, float *v, int nodes, float *x0, Node *tempNodes)
{
	SbVec3f pos = SbVec3f(x);
	SbVec3f vel = SbVec3f(v);
	int nr = 0;
	float impulse;
	float v_new;
	SbLine line;
	SbVec3f vel_projected;
	SbVec3f pos_2;
	SbVec3f vel_2;
	SbVec3f distance;



	//second draw with reflection at the normal
	cerr << "Entered detectNodeCollisions" << endl;
	while ( (nr/3) < nodes-1 )
	{
		nr+=3;
		pos_2 = SbVec3f(x+nr);
		distance = pos - pos_2;
		if(distance.length() < 4.0f)
		{	
			vel_2 = SbVec3f(v+nr);
			//compute the impulse
			impulse = vel.length()*tempNodes[0].mass + vel_2.length()*tempNodes[nr/3].mass;
			//compute new velocity
			v_new = impulse/(tempNodes[0].mass+tempNodes[nr/3].mass);
			//create line connecting the two nodes
			line = SbLine(pos, pos_2-pos);
			//project velocity onto the line connecting the two nodes
			vel_projected = line.getClosestPoint(pos+vel);
			//now mirror velocity at the line connecting the two nodes
			vel = ((pos + vel) + 2*(vel_projected-(pos+vel)) ) - pos;
			//set v_new and reflect:
			vel.normalize();
			vel = -0.8f*v_new*vel;
			vel.getValue(v[0], v[1], v[2]);
			//reset position
			x[0] = x0[0];
			x[1] = x0[1];
			x[2] = x0[2];
			//create line connecting the two nodes, other way around
			line = SbLine(pos_2, pos-pos_2);
			//project velocity onto the line connecting the two nodes
			vel_projected = line.getClosestPoint(pos_2+vel_2);
			//now mirror velocity at the line connecting the two nodes
			vel = ((pos_2 + vel_2) + 2*(vel_projected-(pos_2+vel_2)) ) - pos_2;
			//set v_new and reflect:
			vel_2.normalize();
			vel_2 = -0.8f*v_new*vel_2;
			vel_2.getValue((v+nr)[0],(v+nr)[1],(v+nr)[2]);
			//reset position
			(x+nr)[0] = (x0+nr)[0];
			(x+nr)[1] = (x0+nr)[1];
			(x+nr)[2] = (x0+nr)[2];
		}
		pos_2 = SbVec3f(x+nr);
		cerr << "Node collision with node nr. " << nr/3 << endl;
	}

	//first draw
	//for(int i=0; i<nNodes; i++)
	//{
	//	for(int j=0; j<nNodes; j++)
	//	{
	//		if(i!=j)
	//		{
				
	//			if( (distance.length()) < ((float)spheres[i]->radius.getValue() + (float)spheres[j]->radius.getValue()) )
	//				cerr << "We have a collision between two nodes: " << i << " and " << j << endl;
	//		}
	//	}
	//}

}

void Simulation::pauseSimulation()
{
	pause = !pause;
	if(pause)
	{
		cerr << "Simulation paused." << endl;
	}
	else
	{
		cerr << "Simulation unpaused." << endl;
	}
}

void Simulation::updateSimulation(void)
{
   if(pause)
   {
      return;
   }

   //Perform animation
   animate();

   //Update the rendering objects
   for(int i=0; i<nNodes; i++)
   {
      //Update sphere transform based on point
      nodeTrans[i]->translation.setValue(nodes[i]->position);
   }
   for(i=0; i<nSprings; i++)
   {
      //Update cylinder transform based on spring
      springTrans[i]->pointAt(springs[i]->position, springs[i]->node1->position);

      //Update cylinder length
      cylinders[i]->height=springs[i]->currentLength;
   }
   
}

void Simulation::getNodeStates(float *x, float *v)
{
	//cerr << "getNodeStates: getting states..." << endl;
	for(int i=0, j=0; i<nNodes; i++)
	{
		if(!nodes[i]->stiff)
		{
			//cerr << "state for nonstiff node nr." << i << endl;
			nodes[i]->getState(x+j, v+j);
			tempNodes[j/3] = nodes[i];
			//cerr << "received " << i << endl;
			j+=3;
		}
	}
	//cerr << "getNodeStates: ...all states read." << endl;
}

void Simulation::setNodeStates(float *x, float *v)
{
	for(int i=0, j=0; i<nNodes; i++)
	{
		if(!nodes[i]->stiff)
		{
			detectWallCollisions(x+j,v+j);
			detectNodeCollisions(x+j,v+j, nNodes-(j/3), x0+j, tempNodes[j/3]);
			nodes[i]->setState(x+j, v+j);
			j+=3;
		}
	}
}

void Simulation::getDerivatives(float *v, float *a)
{
	for(int i=0, j=0; i<nNodes; i++)
	{
		if(!nodes[i]->stiff)
		{
			nodes[i]->getDerivatives(v+j, a+j);
			j+=3;
		}
   }
}

void Simulation::integrate(float *x, float *v, float t, float *xnew)
{
	//cerr << "integrate: Starting to integrate..." << endl;
	for (int i=0; i<nMovNodes*3; i++)
	{	
		//cerr << "integrate: integrating node nr. " << i/3 << ", component "<< i%3 << endl;
		//cerr << "integrate: with values: " << x[i] << ", " << t << ", " << v[i] << endl;
		xnew[i]=x[i]+t*v[i];
		//cerr << "integrate: node nr. " << i << " integrated." << endl;
	}
}


void Simulation::createForce(void *data, SbPlaneProjector *proj)
{
	projector = proj;
	force = new Force((Node*)data);
	
	//cerr << "Force created: " << force << endl;
}

void Simulation::eraseForce()
{
	delete projector;
	projector = NULL;
	
	delete force;
	force = NULL;

	//cerr << "Force erased." << endl;
}

void Simulation::updateForce(SbVec2f &screenPosition)
{
	force->updatePosition(projector->project(screenPosition));
}

bool Simulation::forceAvailable()
{
	return force!=NULL;
}

void Simulation::nimLeapFrog(void)
{	
	//cerr << "nLF: Beginning Leap-Frog." << endl;
	getNodeStates(x0, v0);
	//cerr << "nLF: Reveived node states:" << endl;
	//for(int i=0; i < 3*nMovNodes; i++)
	//{
	//	cerr << "nLF: x0["<<i<<"] :" << x0[i] << endl;
	//	cerr << "nLF: v0["<<i<<"] :" << v0[i] << endl;
	//}
	//First computation
	//cerr << "nLF: Computing forces..." << endl;
	computeForces();
	//cerr << "nLF: forces computed." << endl;
	//cerr << "nLF: Computing derivatives..." << endl;
	getDerivatives(k1, l1);
	//cerr << "nLF: derivatives computed." << endl;
	//for(int k=0; k < 3*nMovNodes; k++)
	//{
	//	cerr << "nLF: dx["<<k<<"] :" << k1[k] << endl;
	//	cerr << "nLF: dv["<<k<<"] :" << l1[k] << endl;
	//}
	//cerr << "nLF: Computing new velocities..." << endl;
	integrate(v0, l1, simStepsize, v);
	//cerr << "nLF: velocities updated." << endl;
	//cerr << "nLF: Computing new positions..." << endl;
	integrate(x0, v, simStepsize, x);
	//cerr << "nLF: positions updated." << endl;
	//cerr << "nLF: Setting new node states..." << endl;
	setNodeStates(x, v);
	//cerr << "nLF: node states set." << endl;
	//cerr << "nLF: Updating springs..." << endl;
	updateSprings();
	//cerr << "nLF: springs updated." << endl;
}

void::Simulation::nimRungeKutta4(void)
{
	getNodeStates(x0, v0);

	//First computation
	computeForces();
	getDerivatives(k1, l1);
	integrate(v0, l1, simStepsize/2, k2);
	integrate(x0, k1, simStepsize/2, x);
	setNodeStates(x, k2);
	updateSprings();

	//Second computation
	computeForces();
	getDerivatives(v, l2);
	integrate(v0, l2, simStepsize/2, k3);
	integrate(x0, k2, simStepsize/2, x);
	setNodeStates(x, k3);
	updateSprings();

	//Third computation
	computeForces();
	getDerivatives(v, l3);
	integrate(v0, l3, simStepsize, k4);
	integrate(x0, k3, simStepsize, x);
	setNodeStates(x, k4);
	updateSprings();

	//Forth computationMy
	computeForces();
	getDerivatives(v, l4);
	for(int i=0; i<nNodes*3; i++)
	{
		x[i]=x0[i]+simStepsize/6.0f*(k1[i]+2*k2[i]+2*k3[i]+k4[i]);
		v[i]=v0[i]+simStepsize/6.0f*(l1[i]+2*l2[i]+2*l3[i]+l4[i]);
	}
	setNodeStates(x, v);
	updateSprings();
}