// Spring.cpp: Implementierung der Klasse Spring.
//
//////////////////////////////////////////////////////////////////////

#include "Node.h"
#include "Spring.h"

#include <Inventor/SbLinear.h>

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

float Spring::stiffness = 10000.0f;

Spring::Spring(Node *nodeA, Node *nodeB)
{
	node1 = nodeA;
	node2 = nodeB;
	initialLength = computeLength();
	computePosition();
}

Spring::~Spring()
{

}

void Spring::addForces()
{
	SbVec3f force = (stiffness*(initialLength-currentLength)/currentLength)*(node1->position-node2->position);
	node1->addForce(force);
	node2->addForce(-force);
}

float Spring::computeLength()
{
	currentLength = (node1->position-node2->position).length();
	return currentLength;
}

void Spring::computePosition()
{
	position = (0.5f*node1->position) + (0.5f*node2->position);
}

void Spring::update()
{
	computeLength();
	computePosition();
}